
Public Support - Support Request #12409

Read each sample from queue and transmit at once

2020-10-30 10:42 - hidden

Status: Closed   

Priority: Normal   

Category:    

Customer: CARIAD Product Issue

Numbers:

 

Department: D/CS-G33 Affected Products: ADTF 3.7.1

Requester's Priority: Normal Platform: Windows 10 64bit

Support Level: 2nd Level Topic: ADTF::FilterSDK

Resolution: Solved Issue FAQ Links:  

Description

Supportanfrage

Ich habe ein Plugin auf Basis cTriggerFunction, welches Rohdaten am Eingang in Ausgangs-Samples umsetzt. Die Eingangsdaten

können gelegentlich genug Informationen enthalten, um mehrere Ausgangs-Samples zu generieren:

tResult PluginX::Process(tTimeStamp i_tmTimeOfTrigger)

{

    while(reason) {

       ...

       RETURN_IF_FAILED(TransmitData(nOutputTimeStamp));

    }

}

 Hier kann man feststellen, daß die in einem Rutsch innerhalb der Schleife versendeten Daten im nachfolgenden Filter nicht allesamt

ankommen, sondern nur das erste (?) versendete Sample.

Wie geht man in einem solchen Fall vor? Muß ich eine Queue anlegen, die mittels externem Trigger (z.B. Timer) Sample für Sample

abgebaut wird?

Lösung

While-Schleife über GetNextSample() verwenden.

Es wurde nur ein einfaches GetNextSample aufgerufen. Die Samples werden also in diesem Fall nicht einzeln getriggert, sondern

müssen aus der Queue allesamt rausgelesen werden. Das fiel bisher nicht auf, da zuvor nur ein Transmit getätigt wurde.

History

#1 - 2020-10-30 12:34 - hidden

- Status changed from New to In Progress

- Topic set to ADTF::FilterSDK

#2 - 2020-11-02 09:04 - hidden

Hi Patrick,

hmm, ich kann nicht ganz nachvollziehen was du meinst. Also wenn du 10 Samples schreibst sollten bei den nachfolgenden Filtern auch 10 Samples

aus den Readern rauskommen.

Wie sieht denn das Auslesen bei Euch in den Filtern aus? Macht ihr da eine While-Schleife über GetNextSample()?

Grüße,

Martin

#3 - 2020-11-02 09:49 - hidden

Der Tip mit der while-Schleife trifft ins Schwarze: Es wurde nur ein einfaches GetNextSample aufgerufen. Die Samples werden also in diesem Fall

nicht einzeln getriggert, sondern müssen aus der Queue allesamt rausgelesen werden. Das fiel bisher nicht auf, da zuvor nur ein Transmit getätigt
wurde.

Das Ticket kann dann geschlossen werden. Danke.

#4 - 2020-11-02 09:54 - hidden

- Status changed from In Progress to To Be Closed

- Resolution set to Solved Issue

Wunderbar!

#5 - 2020-11-02 11:49 - hidden

- Project changed from 11 to Public Support

- Subject changed from Trasmit von mehreren Samples in einem Rutsch to Read each sample from queue and transmit at once

- Description updated

- Private changed from Yes to No

#6 - 2021-07-26 13:24 - hidden

- Customer changed from Car.SW Org. to CARIAD

#7 - 2022-01-17 08:17 - hidden

- Status changed from To Be Closed to Closed
